#include "stc.h"
#include "usb.h"
#include "util.h"

//DWORD reverse4(DWORD d)
//{
//    DWORD ret;
//
//    ((BYTE *)&ret)[0] = ((BYTE *)&d)[3];
//    ((BYTE *)&ret)[1] = ((BYTE *)&d)[2];
//    ((BYTE *)&ret)[2] = ((BYTE *)&d)[1];
//    ((BYTE *)&ret)[3] = ((BYTE *)&d)[0];
//
//    return ret;
//}

WORD reverse2(WORD w)
{
    WORD ret;

    ((BYTE *)&ret)[0] = ((BYTE *)&w)[1];
    ((BYTE *)&ret)[1] = ((BYTE *)&w)[0];

    return ret;
}

void sleep_us(WORD n)
{
    while (n--)
    {
//        _nop_();
//        _nop_();
//        _nop_();
//        _nop_();
//        _nop_();

//        _nop_();
        _nop_();
        _nop_();
        _nop_();
        _nop_();

        _nop_();
        _nop_();
        _nop_();
        _nop_();
        _nop_();

        _nop_();
        _nop_();
        _nop_();
        _nop_();
        _nop_();

        _nop_();
        _nop_();
        _nop_();
        _nop_();
    }
}

void sleep_ms(WORD n)
{
    while (n--)
        sleep_us(1000);
}

static void SEG7_SetHeader()
{
    UsbInBuffer[0] = '7';
    UsbInBuffer[1] = 'S';
    UsbInBuffer[2] = 'E';
    UsbInBuffer[3] = 'G';
}

void SEG7_ShowLong(long n, char radix)
{
    SEG7_SetHeader();
    UsbInBuffer[4] = 'L';
    UsbInBuffer[5] = 0x01;
    UsbInBuffer[6] = radix;
    UsbInBuffer[7] = 0x00;
    *(long *)&UsbInBuffer[8] = n;

    usb_IN();
}

void SEG7_ShowFloat(float f)
{
    SEG7_SetHeader();
    UsbInBuffer[4] = 'D';
    UsbInBuffer[5] = 0x01;
    UsbInBuffer[6] = 0x00;
    UsbInBuffer[7] = 0x00;
    *(float *)&UsbInBuffer[8] = f;

    usb_IN();
}

void SEG7_ShowCode(BYTE *cod)
{
    SEG7_SetHeader();
    UsbInBuffer[4] = 'C';
    UsbInBuffer[5] = 0x00;
    UsbInBuffer[6] = 0x00;
    UsbInBuffer[7] = 0x00;
    memcpy(&UsbInBuffer[8], cod, 8);

    usb_IN();
}

int SEG7_ShowString (const char *fmt, ...)
{
    va_list va;
    int ret;

    SEG7_SetHeader();
    UsbInBuffer[4] = 'S';
    UsbInBuffer[5] = 0x00;
    UsbInBuffer[6] = 0x00;
    UsbInBuffer[7] = 0x00;

    va_start(va, fmt);
    ret = vsprintf(&UsbInBuffer[8], fmt, va) + 8;
    va_end(va);

    usb_IN();

    return ret;
}

int printf_hid (const char *fmt, ...)
{
    va_list va;
    int ret;

    va_start(va, fmt);
    ret = vsprintf(&UsbInBuffer[0], fmt, va) + 8;
    va_end(va);

    usb_IN();

    return ret;
}

void LED40_SendData(BYTE *dat, BYTE size)
{
    if (size > 59)
        size = 59;

    UsbInBuffer[0] = 'L';
    UsbInBuffer[1] = 'E';
    UsbInBuffer[2] = 'D';
    UsbInBuffer[3] = 40;
    UsbInBuffer[4] = size;
    memcpy(&UsbInBuffer[5], dat, size);

    usb_IN();
}

void LED64_SendData(BYTE *dat, BYTE size)
{
    if (size > 59)
        size = 59;

    UsbInBuffer[0] = 'L';
    UsbInBuffer[1] = 'E';
    UsbInBuffer[2] = 'D';
    UsbInBuffer[3] = 64;
    UsbInBuffer[4] = size;
    memcpy(&UsbInBuffer[5], dat, size);

    usb_IN();
}

static void LCD12864_SetHeader()
{
    UsbInBuffer[0] = 'L';
    UsbInBuffer[1] = 'C';
    UsbInBuffer[2] = 'D';
    UsbInBuffer[3] = 128;
}

void LCD12864_DisplayOff()
{
    LCD12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xa0;
    UsbInBuffer[6] = 0x00;

    usb_IN();
}

void LCD12864_DisplayOn()
{
    LCD12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xa0;
    UsbInBuffer[6] = 0x01;

    usb_IN();
}

void LCD12864_CursorOff()
{
    LCD12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xa1;
    UsbInBuffer[6] = 0x00;

    usb_IN();
}

void LCD12864_CursorOn()
{
    LCD12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xa1;
    UsbInBuffer[6] = 0x01;

    usb_IN();
}

void LCD12864_CursorMoveLeft()
{
    LCD12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xa2;
    UsbInBuffer[6] = 0x00;

    usb_IN();
}

void LCD12864_CursorMoveRight()
{
    LCD12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xa2;
    UsbInBuffer[6] = 0x01;

    usb_IN();
}

void LCD12864_CursorReturnHome()
{
    LCD12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xa2;
    UsbInBuffer[6] = 0x02;

    usb_IN();
}

void LCD12864_ScrollLeft()
{
    LCD12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xa3;
    UsbInBuffer[6] = 0x00;

    usb_IN();
}

void LCD12864_ScrollRight()
{
    LCD12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xa3;
    UsbInBuffer[6] = 0x01;

    usb_IN();
}

void LCD12864_ScrollUp(BYTE line)
{
    LCD12864_SetHeader();
    UsbInBuffer[4] = 3;
    UsbInBuffer[5] = 0xa3;
    UsbInBuffer[6] = 0x02;
    UsbInBuffer[7] = line;

    usb_IN();
}

void LCD12864_AutoWrapOff()
{
    LCD12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xa4;
    UsbInBuffer[6] = 0x00;

    usb_IN();
}

void LCD12864_AutoWrapOn()
{
    LCD12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xa4;
    UsbInBuffer[6] = 0x01;

    usb_IN();
}

void LCD12864_ReverseLine(BYTE line)
{
    LCD12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xa5;
    UsbInBuffer[6] = line;

    usb_IN();
}

void LCD12864_DisplayClear()
{
    LCD12864_SetHeader();
    UsbInBuffer[4] = 1;
    UsbInBuffer[5] = 0xa6;

    usb_IN();
}

static void LCD12864_SetBuffer(BYTE *dat, WORD size)
{
    BYTE cnt;
    WORD addr;

    addr = 0;
    while (size)
    {
        cnt = 56;
        if (size < 56)
            cnt = size;

        LCD12864_SetHeader();
        UsbInBuffer[4] = cnt + 3;
        UsbInBuffer[5] = 0xaf;
        *(WORD *)&UsbInBuffer[6] = addr;
        memcpy(&UsbInBuffer[8], dat, cnt);

        usb_IN();

        dat += cnt;
        addr += cnt;
        size -= cnt;
    }
}

void LCD12864_ShowString(BYTE x, BYTE y, char *str)
{
    LCD12864_SetBuffer(str, strlen(str) + 1);

    LCD12864_SetHeader();
    UsbInBuffer[4] = 3;
    UsbInBuffer[5] = 0xa7;
    UsbInBuffer[6] = x;
    UsbInBuffer[7] = y;

    usb_IN();
}

void LCD12864_ShowPicture(BYTE x, BYTE y, BYTE cx, BYTE cy, BYTE *dat)
{
    LCD12864_SetBuffer(dat, (WORD)(2UL*cx*cy));

    LCD12864_SetHeader();
    UsbInBuffer[4] = 5;
    UsbInBuffer[5] = 0xa8;
    UsbInBuffer[6] = x;
    UsbInBuffer[7] = y;
    UsbInBuffer[8] = cx;
    UsbInBuffer[9] = cy;

    usb_IN();
}

static void OLED12864_SetHeader()
{
    UsbInBuffer[0] = 'O';
    UsbInBuffer[1] = 'L';
    UsbInBuffer[2] = 'E';
    UsbInBuffer[3] = 128;
}

void OLED12864_DisplayOff()
{
    OLED12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xc0;
    UsbInBuffer[6] = 0x00;

    usb_IN();
}

void OLED12864_DisplayOn()
{
    OLED12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xc0;
    UsbInBuffer[6] = 0x01;

    usb_IN();
}

void OLED12864_DisplayContent()
{
    OLED12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xc1;
    UsbInBuffer[6] = 0x00;

    usb_IN();
}

void OLED12864_DisplayEntire()
{
    OLED12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xc1;
    UsbInBuffer[6] = 0x01;

    usb_IN();
}

void OLED12864_HorizontalMirror()
{
    OLED12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xc2;
    UsbInBuffer[6] = 0x00;

    usb_IN();
}

void OLED12864_VerticalMirror()
{
    OLED12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xc2;
    UsbInBuffer[6] = 0x01;

    usb_IN();
}

void OLED12864_DisplayReverse()
{
    OLED12864_SetHeader();
    UsbInBuffer[4] = 1;
    UsbInBuffer[5] = 0xc3;

    usb_IN();
}

void OLED12864_SetContrast(BYTE bContrast)
{
    OLED12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xc4;
    UsbInBuffer[6] = bContrast;

    usb_IN();
}

void OLED12864_SetAddressMode(BYTE bMode)
{
    OLED12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xc5;
    UsbInBuffer[6] = bMode;

    usb_IN();
}

void OLED12864_ScrollLeft(BYTE bPageStart, BYTE bPageEnd, WORD nInterval)
{
    OLED12864_SetHeader();
    UsbInBuffer[4] = 6;
    UsbInBuffer[5] = 0xc6;
    UsbInBuffer[6] = 0x00;
    UsbInBuffer[7] = bPageStart;
    UsbInBuffer[8] = bPageEnd;
    *(WORD *)&UsbInBuffer[9] = nInterval;

    usb_IN();
}

void OLED12864_ScrollRight(BYTE bPageStart, BYTE bPageEnd, WORD nInterval)
{
    OLED12864_SetHeader();
    UsbInBuffer[4] = 6;
    UsbInBuffer[5] = 0xc6;
    UsbInBuffer[6] = 0x01;
    UsbInBuffer[7] = bPageStart;
    UsbInBuffer[8] = bPageEnd;
    *(WORD *)&UsbInBuffer[9] = nInterval;

    usb_IN();
}

void OLED12864_ScrollUp(BYTE bPageStart, BYTE bPageEnd, WORD nInterval)
{
    OLED12864_SetHeader();
    UsbInBuffer[4] = 6;
    UsbInBuffer[5] = 0xc6;
    UsbInBuffer[6] = 0x02;
    UsbInBuffer[7] = bPageStart;
    UsbInBuffer[8] = bPageEnd;
    *(WORD *)&UsbInBuffer[9] = nInterval;

    usb_IN();
}

void OLED12864_ScrollStart()
{
    OLED12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xc7;
    UsbInBuffer[6] = 0x01;

    usb_IN();
}

void OLED12864_ScrollStop()
{
    OLED12864_SetHeader();
    UsbInBuffer[4] = 2;
    UsbInBuffer[5] = 0xc7;
    UsbInBuffer[6] = 0x00;

    usb_IN();
}

static void OLED12864_SetBuffer(BYTE *dat, WORD size)
{
    BYTE cnt;
    WORD addr;

    addr = 0;
    while (size)
    {
        cnt = 56;
        if (size < 56)
            cnt = size;

        OLED12864_SetHeader();
        UsbInBuffer[4] = cnt + 3;
        UsbInBuffer[5] = 0xcf;
        *(WORD *)&UsbInBuffer[6] = addr;
        memcpy(&UsbInBuffer[8], dat, cnt);

        usb_IN();

        dat += cnt;
        addr += cnt;
        size -= cnt;
    }
}

void OLED12864_ShowPicture(BYTE x, BYTE y, BYTE cx, BYTE cy, BYTE *dat)
{
    OLED12864_SetBuffer(dat, (WORD)cx*cy);

    OLED12864_SetHeader();
    UsbInBuffer[4] = 5;
    UsbInBuffer[5] = 0xc8;
    UsbInBuffer[6] = x;
    UsbInBuffer[7] = y;
    UsbInBuffer[8] = cx;
    UsbInBuffer[9] = cy;

    usb_IN();
}

